Post not yet marked as solved
Hello, I have followed all the documentation for my new iOS Application, I have. uploaded apple-app-site-association file to the server's /.well-known/ folder.
Error no apps with domain entitlements
The entitlement data used to verify deep link dual authentication is from the current released version of your app. This data may take 48 hours to update.
My application is uploaded to test-flight not published on Apple store, I want to test and verify universal links before releasing it publicly, at the moment deep links are not working.
I am following the exact documentation.
I added http and https schemes in URL TYPES:
Added applinks to domain association :
apple-app-site-association file:-
{
"applinks": {
"apps": [],
"details": [
{
"appID": "<TEAMID>.<APP_IDENTIFIED>",
"paths": [ "*" ]
}
]
}
}
Post not yet marked as solved
Hello,
We release an App Clip back in December 2020, and everything was working just fine for the longest time. However, sometime relatively recently, not exactly sure when it started, the Domain URL Status started showing this “Cannot Reach AASA File” error; and consequently, the App Clip invocation fails now.
The API Validation Tool is saying “Error cannot parse app site association file” as the reason.
We have not made any changes in the App / App Clip, and the associated domain is still set as appclips:mobileapp.caesars.com
The Apple App Site Association file hasn’t been changed either, and the format still matches that specified on https://developer.apple.com/documentation/app_clips/associating_your_app_clip_with_your_website.
The AASA file returns no problem in a browser and from curl command as you can see below:
Last login: Tue Jul 12 09:11:11 on console
curl -v https://mobileapp.caesars.com/.well-known/apple-app-site-association
* Trying 192.230.66.155:443...
* Connected to mobileapp.caesars.com (192.230.66.155) port 443 (#0)
* ALPN, offering h2
* ALPN, offering http/1.1
* successfully set certificate verify locations:
* CAfile: /etc/ssl/cert.pem
* CApath: none
* (304) (OUT), TLS handshake, Client hello (1):
* (304) (IN), TLS handshake, Server hello (2):
* (304) (IN), TLS handshake, Unknown (8):
* (304) (IN), TLS handshake, Certificate (11):
* (304) (IN), TLS handshake, CERT verify (15):
* (304) (IN), TLS handshake, Finished (20):
* (304) (OUT), TLS handshake, Finished (20):
* SSL connection using TLSv1.3 / AEAD-AES128-GCM-SHA256
* ALPN, server accepted to use h2
* Server certificate:
* subject: C=US; ST=Nevada; L=Las Vegas; O=Caesars License Company, LLC; CN=*.caesars.com
* start date: Jul 28 00:00:00 2020 GMT
* expire date: Oct 14 12:00:00 2022 GMT
* subjectAltName: host "mobileapp.caesars.com" matched cert's "*.caesars.com"
* issuer: C=US; O=DigiCert Inc; CN=DigiCert SHA2 Secure Server CA
* SSL certificate verify ok.
* Using HTTP2, server supports multiplexing
* Connection state changed (HTTP/2 confirmed)
* Copying HTTP/2 data in stream buffer to connection buffer after upgrade: len=0
* Using Stream ID: 1 (easy handle 0x12b810400)
> GET /.well-known/apple-app-site-association HTTP/2
> Host: mobileapp.caesars.com
> user-agent: curl/7.79.1
> accept: */*
>
* Connection state changed (MAX_CONCURRENT_STREAMS == 128)!
< HTTP/2 200
< content-type: application/json
< last-modified: Tue, 29 Mar 2022 17:01:12 GMT
< accept-ranges: bytes
< etag: "8fb84c988e43d81:0"
< server: Microsoft-IIS/10.0
< x-powered-by: ASP.NET
< p3p: CP="DEVa TAIa CURa STA NAV COM PUR ADMa IND OUR CONa"
< date: Tue, 12 Jul 2022 14:13:38 GMT
< content-length: 94
< set-cookie: TLTUID=14DC54AD87C0CE8FE7D996B6462E29DA; Domain=caesars.com; Expires=Sun, 03-Mar-2024 14:13:38 GMT; Path=/
< set-cookie: TLTSID=CE56628D3C96FCC7119B576D984C3119; Domain=caesars.com; Path=/
< set-cookie: visid_incap_2158031=HUn4aDqCSo+WP67o1FH52pGBzWIAAAAAQUIPAAAAAAB3XfZ+ShjpzS05c/MsxAjO; expires=Wed, 12 Jul 2023 06:18:20 GMT; HttpOnly; path=/; Domain=.caesars.com
< set-cookie: nlbi_2158031=q84xFZbqUDGbu15TtwLJSwAAAABBaYw0KJNNHWaeJ2p5/DNV; path=/; Domain=.caesars.com
< set-cookie: incap_ses_979_2158031=w4MXYaAK4R7YuhVx/BuWDZGBzWIAAAAA8Dt1Yyj9qc8nFNp3F96Kxg==; path=/; Domain=.caesars.com
< x-cdn: Imperva
< x-iinfo: 11-18630097-18630107 NNNY CT(35 74 0) RT(1657635217346 57) q(0 0 0 1) r(0 0) U12
<
{
"appclips": {
"apps": [
"YXFZ76LPGW.com.caesars.playbytr.Clip"
]
}
* Connection #0 to host mobileapp.caesars.com left intact
Again, this was all working without any problems and just suddenly stopped for some reason without any apparent explanation. I’ve looked at similar issues reported in the forums with no luck helping solve this issue yet. Any guidance/help would be greatly appreciated!
Post not yet marked as solved
We are developing an app using flutter, and we have also uploaded apple-app-site-association. The universal link is working fine with iPhone SE (15.5) and iPhone 8 (15.0). However, it's not working with iPhone 8 15.5, iPhone 11 15.5, and iPhone 13. Please take a look into this issue and let us know any help on this.
Thank You.
Post not yet marked as solved
We have been having problems with our app clip not working when sharing through iMessage. The app and app clip are published and work correctly when scanning a QR code that points to the URL: https://www.coderus.com/locations?loc=1 however if this same URL is shared through the iMessage app, a link to the website displays and not the app clip card.
We have confirmed that:
AASA file is available and has the type application/json
Both devices are above iOS 14
Both devices are in each other's contacts
The website has the meta tag for the smart app clip banner
The website has a meta tag for the og:image
Launch experiences have been configured on AppStoreConnect - as said before, the QR codes work correctly
The link leads to a 404 page, I wasn't sure if there needs to be an actual page that the link points to as app clips seem to work fine without when scanning the QR code through the camera app.
Post not yet marked as solved
Universal links stops working randomly,
When i tried this curl API test i found strange result
Case 1: When the curl test return association JSON response it works fine
Case 2: Sometimes the curl test fails and association JSON response is not returned for the same log is below: (Actual domain is replaced by mydomain.com)
Https enabled
No redirections
Association added in .well-known folder
Works randomly without any change in sever
IP added as exception in blacklist
Applebot added as:
User-agent: Applebot
Allow: /.well-known/
Curl API Test Response:
Using Terminal:
curl -v https://app-site-association.cdn-apple.com/a/v1/mydomain.com
* Trying 8.241.155.124:443...
* Connected to app-site-association.cdn-apple.com (8.241.155.124) port 443 (#0)
* ALPN, offering h2
* ALPN, offering http/1.1
* successfully set certificate verify locations:
* CAfile: /etc/ssl/cert.pem
* CApath: none
* (304) (OUT), TLS handshake, Client hello (1):
* (304) (IN), TLS handshake, Server hello (2):
* (304) (IN), TLS handshake, Unknown (8):
* (304) (IN), TLS handshake, Certificate (11):
* (304) (IN), TLS handshake, CERT verify (15):
* (304) (IN), TLS handshake, Finished (20):
* (304) (OUT), TLS handshake, Finished (20):
* SSL connection using TLSv1.3 / AEAD-AES256-GCM-SHA384
* ALPN, server accepted to use http/1.1
* Server certificate:
* subject: CN=app-site-association.cdn-apple.com; OU=management:idms.group.5707244; O=Apple Inc.; ST=California; C=US
* start date: Sep 1 20:44:29 2021 GMT
* expire date: Oct 1 20:44:28 2022 GMT
* subjectAltName: host "app-site-association.cdn-apple.com" matched cert's "app-site-association.cdn-apple.com"
* issuer: CN=Apple Public Server RSA CA 12 - G1; O=Apple Inc.; ST=California; C=US
* SSL certificate verify ok.
> GET /a/v1/mydomain.com HTTP/1.1
> Host: app-site-association.cdn-apple.com
> User-Agent: curl/7.79.1
> Accept: */*
>
* Mark bundle as not supporting multiuse
< HTTP/1.1 404 Not Found
< Date: Tue, 28 Jun 2022 06:51:03 GMT
< Content-Type: text/plain; charset=utf-8
< Content-Length: 10
< Connection: keep-alive
< Apple-Failure-Details: {"cause":"context deadline exceeded (Client.Timeout exceeded while awaiting headers)"}
< Apple-Failure-Reason: SWCERR00301 Timeout
< Apple-From: https://mydomain.com/.well-known/apple-app-site-association
< Apple-Try-Direct: true
< Cache-Control: public, max-age=1800
< Expires: Tue, 28 Jun 2022 06:51:23 GMT
< X-Cache: MISS
< CDNUUID: 2478cf3a-1d35-4870-ae61-0ad342ef8adf-1481196180
< CDN-Server: lumn
< Age: 1238
<
Not Found
* Connection #0 to host app-site-association.cdn-apple.com left intact
Please support, Urgent Help Required.
Post not yet marked as solved
Bonjour, je cherche le lien universel vers l'application mesures. Le but est de l'utiliser depuis une autre application.
Nous avons créer une autre application pour prise de commande et devis pour travaux immobiliers.
L'application proposera un lien pour ouvrir directement l'application mesures de Apple.
Les images seront récupérées par notre application pour compléter le devis.
Ouvrir l'application measure comme ouvrir l'appareil photo depuis une autre application
1iOS - Universal links
Universal links sont la méthode d'Apple pour lancer des applications sur iOS lorsqu'elles sont liées à partir d'un site Web.
Les universal links sont disponibles depuis iOS 9 et versions ultérieures.
Les universal links sont des liens Web standard (par exemple : https://www.mondomaine.com) qui pointent à la fois vers une page PWA spécifique et une page d'application native.
Lorsqu'un lien universel est défini, iOS vérifie si un appareil installé est enregistré pour ce domaine.
Si tel est le cas, l'application native est lancée immédiatement sans charger la page PWA.
Sinon, votre PWA est lancée sur l'URL Web spécifique.
Post not yet marked as solved
Hello,
I was referred to you to address the issue below. I hope you can help.
We manufacture and sell ******** making tools (https://barillio-barware.com). In each product box we provide a complimentary booklet with ******** recipes.
We would like to add to each recipe page in the booklet, a unique QR-Code with link to Apple Music playlist of mood songs to listen while making that specific ********. See sample below.
Are we allowed to use the logo and playlists in the way shown in the pictures?
Can we use a QR-Code linking to Apple Music playlist without any Apple Music logo?
Thank you.
Post not yet marked as solved
I am considering implementing a universal link. I want to check the communication requirements when referencing apple-app-site-association from the app and Apple CDN.
For example, I would like to confirm the following communication requirements.
・ Communication: https
・ Access frequency: 1 week
-Search method of apple-app-site-association: Refer to all under the domain. Or refer only to the domain and well-known.
Post not yet marked as solved
We have verified that UniversalLink cannot be used with AppClip.
However, the documentation does not clearly state this.
Can I use UniversalLink with AppClip?
Post not yet marked as solved
When I set Associate Domains in Xcode, I use this format applinks:***.***.com.cn:9090 , Is that a problem
?
Post not yet marked as solved
Hi everyone!
I have some issue with universal links. I follow this document from App Search Programming Guide
And I create 3 apps associated with the same page and settings. It works perfectly when I read the QR code with native camera.
But when I read a QR code with the QR Code Scanner from Control Center always opens App1
Example:
I select App3
Show App3 Icon
But open App1!!!
I configure my AASA file something like this:
`{
"applinks": {
"apps": [],
"details": [{
"appID": "TeamId.bundleApp1",
"paths": [
"*"
]
},
{
"appID": "TeamId.bundleApp2",
"paths": [
"*"
]
},
{
"appID": "TeamId.bundleApp3",
"paths": [
"*"
]
}
]
}
}`
Thanks!!!
Post not yet marked as solved
I've an app which uses associated domains capability to enable universal links and password saving. Both features are working, except for one tiny detail.
There are two domains associated with the app. Primary domain is the one commonly used to access the web app and the secondary domain is added due to historic reasons and handling universal links to older domain. When user sign in to the app using username and password it always gets saved against the secondary domain name and not the primary one. I tried changing the order in which the domains are defined in the entitlements file but no joy. I even tried adding webcredentials key to ASA file under both domains and that didn't work as well. Is there a way to direct iOS to prefer one domain over the other so that credential gets saved against the primary domain?
Post not yet marked as solved
Hi guys! I'm having some issues geting Universal Links to work.
I have uploaded an association file to my website.
I have added applink Entitlements to my app.
Now...
I can see in my phone, Settings->Developer->Universal Links->Diagnostics, that my URL "Opens Installed Application".
But when i click the URL in an email or messenger, it just opens in safari.
Any ideas?
Post not yet marked as solved
Hello,
We are getting 403 error from Apple's CDN when app installs, also tried checking other threads be didn't get an answer, Everything worked great for the pas year, until about a week ago when we began getting this error.
Attached the log from the curl command.
Thanks
* Trying 17.253.105.202:443...
* Connected to app-site-association.cdn-apple.com (17.253.105.202) port 443 (#0)
* ALPN, offering h2
* ALPN, offering http/1.1
* successfully set certificate verify locations:
* CAfile: /etc/ssl/cert.pem
* CApath: none
* (304) (OUT), TLS handshake, Client hello (1):
* (304) (IN), TLS handshake, Server hello (2):
* (304) (IN), TLS handshake, Unknown (8):
* (304) (IN), TLS handshake, Certificate (11):
* (304) (IN), TLS handshake, CERT verify (15):
* (304) (IN), TLS handshake, Finished (20):
* (304) (OUT), TLS handshake, Finished (20):
* SSL connection using TLSv1.3 / AEAD-AES128-GCM-SHA256
* ALPN, server accepted to use http/1.1
* Server certificate:
* subject: CN=app-site-association.cdn-apple.com; OU=management:idms.group.665035; O=Apple Inc.; ST=California; C=US
* start date: Aug 5 18:09:37 2021 GMT
* expire date: Sep 4 18:09:36 2022 GMT
* subjectAltName: host "app-site-association.cdn-apple.com" matched cert's "app-site-association.cdn-apple.com"
* issuer: CN=Apple Public Server ECC CA 12 - G1; O=Apple Inc.; ST=California; C=US
* SSL certificate verify ok.
> GET /a/v1/static.bankhapoalim.co.il HTTP/1.1
> Host: app-site-association.cdn-apple.com
> User-Agent: curl/7.79.1
> Accept: */*
>
* Mark bundle as not supporting multiuse
< HTTP/1.1 404 Not Found
< Date: Sun, 22 May 2022 13:16:13 GMT
< Content-Type: text/plain; charset=utf-8
< Content-Length: 10
< Apple-Failure-Details: {"status":"403 Forbidden"}
< Apple-Failure-Reason: SWCERR00101 Bad HTTP Response: 403 Forbidden
< Apple-From: https://static.bankhapoalim.co.il/.well-known/apple-app-site-association
< Apple-Try-Direct: false
< Cache-Control: max-age=1800,public
< Age: 284
< Via: https/1.1 uklon5-vp-vst-001.ts.apple.com (acdn/146.13260), https/1.1 uklon5-vp-vfe-020.ts.apple.com (acdn/146.13260), http/1.1 nlsrk1-edge-lx-006.ts.apple.com (acdn/144.13255), http/1.1 nlsrk1-edge-bx-008.ts.apple.com (acdn/144.13255)
< X-Cache: hit-stale, hit-stale, hit-fresh, hit-fresh
< CDNUUID: 642df845-fbba-404b-b94b-f9e62d744d9a-12840492660
< Expires: Sun, 22 May 2022 13:16:23 GMT
< Connection: keep-alive
<
Not Found
* Connection #0 to host app-site-association.cdn-apple.com left intact
Post not yet marked as solved
Hi.
I have defined the following AASA File for my app:
{
"applinks": {
"apps": [],
"details": [
{
"appID": "xxxxxx.com.company.app",
"paths": [ "NOT /", "/path1/*", "/path2/*"],
}
]
}
}
The goal was to just allow path1 and path2 to be opened by the app - all other urls like password reset urls .. should be opened in browser. I have deleted the app from the phone and restarted the phone. Afterwards I have installed the current app. I have sent multiple types of urls via iMessage to the test device then.
After first try, the url which does not include path1 or path2 opens in browser. Then I tried one which should be opened by the app - worked also. After that I retried the excluded url -> app is also opened! From that point on the app is always opened.
So my question is why is the excluding logic only working on first try, and then the app is always opened?!
What is the best way to achieve this? Is my definition maybe wrong?
(Testdevice is running 14.6)
Post not yet marked as solved
I've been working trying to get Universal Links working for the past few days and it has been an adventure. Using the App Search API Validation Tool has been challenging. I've seen many posts from others looking for "why" their AASA file has been rejected.
When I compare AASA files (I've only been able to find 1 so far that passes and that is Twitter.
What would really help (in my opinion) would be to give more information regarding what this tool does and what are the factors are. I find the error messaging very opaque. Answers to Error cannot parse app site association well if it's valid JSON, why can't the service say what it doesn't like?
What does it mean that no apps associated with url, does it mean that no apple bundle can be found on the app store? Does it mean Universal links will not work, period?
I get a sense that there is a lot going on under the hood that is just not described. If that could be exposed that would really be helpful.
Giving devs an idea of how frequently they can do the validation check would be nice. What is the relationship between the deployed bundle and validation. When I test my AASA file, is it testing what's on the website or is going to the CDN?
Maybe give output describing which schema versions and therefore which IOS versions are supported would be great.
I don't want to sound critical, but I was able to get the android version working with hardly any external blogs. I'm currently at this point right now...
Error no apps with domain entitlements
The entitlement data used to verify deep link dual authentication is from the current released version of your app. This data may take 48 hours to update.
I guess I'll come back in a few days to retry. Anyway, don't want to sound like I'm venting. I think some rough edges could be smoothed over with just a few paragraphs of documentation.
Thanks
Post not yet marked as solved
We have a problem with Universal Links working in our iOS app. The reason is that CDN cannot access our apple-app-site-association file due to security settings.
To restore the application, we see the possible ways to solve the problem:
Possibility to find out CDN ip-addresses from which our AASA file is requested and add them to the white list;
Possibility to learn request parameters from CDN, which can be used to form a file access rule;
Possibility to upload our AASA file to CDN manually;
Possibility to specify a special mode in Associated Domains, similar to managed, which will allow all devices to download the aasa file directly.
Is it possible to solve our problem, or is there another solution?
Post not yet marked as solved
I believe I have everything configured correctly for Universal Links to be working, but every method I try to launch a link just takes me to safari. Any ideas would be appreciated!
The app in question is not yet in the app store, but some previous versions are in TestFlight.
Entitlements file:
<plist version="1.0">
<dict>
...
<key>com.apple.developer.associated-domains</key>
<array>
<string>webcredentials:o.s.com</string>
<string>applinks:o.s.com</string>
<string>webcredentials:p.d.org:3011?mode=developer</string>
<string>applinks:p.d.org:3011?mode=developer</string>
<string>applinks:p.d.org?mode=developer</string>
</array>
p.d.org:3011 (not the real url) is a public DNS record that resolves to the LAN IP of my macbook where a dev instance of our server is running with a valid TLS certificate from Let's Encrypt.
o.s.com is the url of the our staging environment, which some TestFlight builds connect to.
The AASA file served by both servers is currently a combination of both old and new formats, but I originally just had what I believe to be the new format (from here):
{
"applinks": {
"apps": [],
"details": [{
"appIDs": [
"the.real.app.id", // <--- redacted
"the.second.app.id"
],
"components": [{
"?": "no_universal_link",
"exclude": true,
"comment": "Exclude any URL with no_universal_link in the query params"
}, {
"/": "/group/browse",
"exclude": true,
"comment": "Exclude group browse list"
}, {
"/": "/invited*",
"comment": "Match invited link"
}]
}, {
"appID:": "the.real.app.id",
"paths": ["/invited*", "/group/*"]
}, {
"appID:": "the.second.app.id",
"paths": ["/invited*", "/group/*"]
}]
},
"webcredentials": {
"apps": [
"the.real.app.id",
"the.second.app.id"
]
},
"activitycontinuation": {
"apps": [
"the.real.app.id",
"the.second.app.id"
]
}
}
I have two phones and an iPad I test on, one phone with the iOS beta installed (currently 15.5 beta 4) and one phone + the iPad with the current public iOS (15.4.1). On all devices, Settings->Developer->Associated Domains Development is ON.
Upon install of a Debug build of the.real.app.id, I confirmed that /.well-known/apple-app-site-association was fetched from my local dev server.
Settings->Developer->Universal Links->Diagnostics shows the following for https://p.d.org:3011:
for https://o.s.com, though, it show a problem, which I'm assuming is due to the debug build not matching a url with ?mode=developer:
In the AppDelegate, I've implemented:
func application(_ application: UIApplication,
continue userActivity: NSUserActivity,
restorationHandler: @escaping ([UIUserActivityRestoring]?) -> Void) -> Bool {
logger.info("continue user activity: \(userActivity.activityType, privacy: .public)")
return true
}
and in the SwiftUI App subclass, I also have:
var body: some Scene {
WindowGroup {
MainContentView()
.onContinueUserActivity(NSUserActivityTypeBrowsingWeb, perform: launchUrl(userActivity:))
.onOpenURL { url in
print("On open url: \(url)")
}
}
}
func launchUrl(userActivity: NSUserActivity) {
logger.info("launchUrl continue user activity: \(userActivity.activityType, privacy: .public)")
}
I've sent myself messages with links to p.d.org:3011 in a number of apps, including iMessage. I've rendered a link into a QR code for use in the camera app. I've even built a second app into which I've hard coded the link to ensure that it calls UIApplication.shared.open(url, options: [:], completionHandler: nil). All of these methods take me to the browser (safari).
For completeness, I'm using the link: https://p.d.org:3011/invited?id=...
When the web opens, a blank app preview banner appears sometimes. I expect that it's blank because the app in question hasn't been publicly released to the app store yet. The landing page doesn't have enough content to scroll the page, and pulling down on the page doesn't reveal the app preview banner when the banner doesn't show.
The logging statements in the app never print.
I've also tried building both Ad Hoc and TestFlight versions of the app for o.s.com. Server logs similarly show the AASA being fetched. But the Diagnostics in Settings show the yellow triangle screen for both p.d.org:3011 and o.s.com.
I'm not sure what I'm doing wrong here, and I can't find any more information on the web. Can someone help me out ...or put me out of my misery?
Post not yet marked as solved
Im using code 13.3 and added deep link support, and associated domains links.
Im using manual signing, and when i try to choose my certificate- i see this error and i'm unable to choose it.
the certificate have associated domain and i triple checked it.
what should i do to try and fix that error ? i cannot archive the app.
Post not yet marked as solved
Hi I need my app to send a link to a customer to ask for their contact details to book an appointment. The problem I have is when I send the link to unknown iPhone it will not allow the link to work as I think it suspects the link to be spam. This will cause a real issue for my app as without this function I can see it working. Any help or advice would be appreciated please. Thanks Noel